-------------------------------------------------------------------------------
-- Title      : Fichier de test pour le timer 64 bits
-- Project    : timer 64 bits
-------------------------------------------------------------------------------
-- File       : test_timer64bits.vhd
-- Author     :   <patrice@SOLEIL>
-- Company    : 
-- Created    : 2010-01-11
-- Last update: 2010/01/24
-- Platform   : 
-- Standard   : VHDL'93
-------------------------------------------------------------------------------
-- Description:
-------------------------------------------------------------------------------
-- Copyright (c) 2010  http://vhdl33.free.fr
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2010-01-11  1.0      patrice	Created
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY test_timer64bits IS
END test_timer64bits;

-- Test includes reset, timer running , writing capture control, reading data

ARCHITECTURE sequence OF test_timer64bits IS

  COMPONENT timer64bits
    PORT (
      reset    : IN  std_ulogic;          
      clk      : IN  std_ulogic;          
      addr     : IN  std_ulogic;           
      cs       : IN  std_ulogic;           
      rd, wr   : IN  std_ulogic;           
      data_in  : IN  std_logic_vector(31 DOWNTO 0);  
      data_out : OUT std_logic_vector(31 DOWNTO 0));  
  END COMPONENT;

  CONSTANT Period : TIME := 10 ns;     -- 100 MHz
  SIGNAL reset, clk, addr, cs, rd, wr : std_ulogic;
  SIGNAL data_in, data_out : std_logic_vector(31 DOWNTO 0);

BEGIN  -- sequence

  T1 : timer64bits PORT MAP (
    reset    => reset,
    clk      => clk,
    addr     => addr,
    cs       => cs,
    rd       => rd,
    wr       => wr,
    data_in  => data_in,
    data_out => data_out);

  clock : PROCESS
  BEGIN  -- PROCESS horloge
    clk <= '1', '0' AFTER Period/2 ;
    WAIT FOR Period;
  END PROCESS clock;

  -- purpose: all stimulus
  PROCESS
  BEGIN  -- PROCESS
    reset <= '1';
    addr <= '0';
    cs <= '0';
    rd <= '0';
    wr <= '0';
    data_in <= (OTHERS => '0');
    WAIT FOR period + 2 ns;             -- shifting time 2 ns
    reset <= '0';
    WAIT FOR 30 * period;               -- now counting
    wr <= '1';  data_in <= X"00000001";  -- bit 0 = '1'
    WAIT FOR period;
    cs <= '1';
    WAIT FOR period;
    cs <= '0'; wr <= '0';                -- now capture register is loaded
    WAIT FOR 10 * period;              -- a little WHILE
    rd <= '1';
      WAIT FOR period; 
    cs <= '1';
    WAIT FOR period;                    -- now 32 high weight to output
    cs <= '0'; addr <= '1';
    WAIT FOR period;
    cs <= '1';
    WAIT FOR period;                     -- now 32low weight to output
    cs <= '0'; rd <= '0'; 
    WAIT FOR 10 * period;                -- a little WHILE
    wr <= '1';  data_in <= X"00000002";  -- bit 1 = '1'
    WAIT FOR period;
    cs <= '1';
    WAIT FOR period;
    cs <= '0'; wr <= '0';
     reset <= '1';
     WAIT FOR period;
    reset <= '0';
    WAIT;                               -- nothing else
  END PROCESS;

  


END sequence;
